# Generated by Django 2.2.3 on 2019-08-06 08:42

from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Defaults',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slo_billing_cycle', models.CharField(choices=[('daily', 'Daily'), ('weekly', 'Weekly'), ('monthly', 'Monthly'), ('yearly', 'Yearly')], default='monthly', help_text='Default SLO billing cycle', max_length=7)),
                ('slo_objective', models.CharField(choices=[('downtime', 'Downtime'), ('brown_hosting', 'Hosting in non-green-powered (brown) servers')], default='dt', help_text='The default SLO objective', max_length=13)),
                ('slo_target_value', models.FloatField(default=0, help_text='The default value that when reached, the SLO is broken')),
                ('slo_unit', models.CharField(choices=[('seconds', 'Seconds'), ('minutes', 'Minutes'), ('hours', 'Hours')], default='m', help_text='The default units of measurement for the value', max_length=7)),
                ('ctn_protocol', models.CharField(choices=[('amqp', 'RabbitMQ'), ('http', 'HTTP'), ('https', 'HTTPS'), ('kafka', 'kafka')], default='http', help_text='The default protocol of the notification', max_length=5)),
                ('ctn_server', models.CharField(help_text='The default server to send the information to', max_length=100)),
                ('ctn_port', models.IntegerField(default=443, help_text='The default port to connect to')),
                ('ctn_service_url', models.CharField(help_text='The default rest of the URL to send the information to', max_length=512)),
                ('ctn_percentage', models.FloatField(default=80.0, help_text="The default percentage of the SLA's SLOs that when reached the notification will be sent")),
                ('sla_duration', models.CharField(choices=[('year', 'One Year'), ('month', 'One Month'), ('week', 'One Week')], default='year', help_text='The default SLA duration', max_length=5)),
            ],
        ),
        migrations.CreateModel(
            name='Event',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, help_text='The id of the event', primary_key=True, serialize=False)),
                ('type', models.CharField(choices=[('downtime', 'Downtime'), ('brown_hosting', 'Hosting in non-green-powered (brown) servers')], default='dt', help_text='The type of the event', max_length=13)),
                ('status', models.CharField(choices=[('active', 'Active'), ('completed', 'Completed'), ('inactive', 'Inactive')], default='active', help_text='The status of the event', max_length=9)),
                ('start_time', models.DateTimeField(help_text='The start time of the event')),
                ('end_time', models.DateTimeField(blank=True, help_text='The end time of the event', null=True)),
                ('value', models.FloatField(default=0, help_text='The current value of the event as to the event type')),
            ],
            options={
                'ordering': ['start_time', 'end_time'],
            },
        ),
        migrations.CreateModel(
            name='SLA',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, help_text='The id of the SLA', primary_key=True, serialize=False)),
                ('valid_from', models.DateTimeField(help_text='The activation time of the SLA')),
                ('valid_until', models.DateTimeField(help_text='The deactivation time of the SLA')),
                ('entity_type', models.CharField(help_text='The entity type to watch', max_length=100)),
                ('entity_id', models.CharField(help_text='The entity type to watch', max_length=100)),
                ('status', models.CharField(choices=[('active', 'Active'), ('completed', 'Completed')], default='active', help_text='The SLA status', max_length=9)),
            ],
        ),
        migrations.CreateModel(
            name='SLO',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, help_text='The id of the SLO', primary_key=True, serialize=False)),
                ('objective', models.CharField(choices=[('downtime', 'Downtime'), ('brown_hosting', 'Hosting in non-green-powered (brown) servers')], default='dt', help_text='The SLO objective', max_length=13)),
                ('target_value', models.FloatField(default=0, help_text='The value that when reached, the SLO is broken')),
                ('current_value', models.FloatField(default=0, help_text='The current SLO value')),
                ('unit', models.CharField(choices=[('seconds', 'Seconds'), ('minutes', 'Minutes'), ('hours', 'Hours')], default='m', help_text='The units of measurement for the value', max_length=7)),
                ('billing_cycle', models.CharField(choices=[('daily', 'Daily'), ('weekly', 'Weekly'), ('monthly', 'Monthly'), ('yearly', 'Yearly')], default='m', help_text='Period for resetting the SLO status', max_length=7)),
                ('last_billed', models.DateTimeField(default=django.utils.timezone.now, help_text='The last time the billing was calculated')),
                ('next_bill', models.DateTimeField(default=django.utils.timezone.now, help_text='The next time the billing will be calculated')),
                ('status', models.CharField(choices=[('ok', 'OK'), ('broken', 'Broken'), ('completed', 'Completed')], default='ok', help_text='The SLO status', max_length=9)),
                ('sla', models.ForeignKey(help_text='The SLA to which this SLO adheres', on_delete=django.db.models.deletion.CASCADE, related_name='slos', to='api.SLA')),
            ],
        ),
        migrations.CreateModel(
            name='Task',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, help_text='The (internal) id of the task', primary_key=True, serialize=False)),
                ('task_id', models.CharField(help_text='The Task id', max_length=36)),
                ('status', models.CharField(choices=[('active', 'active'), ('completed', 'completed'), ('aborted', 'aborted')], default='active', help_text='The status of the task', max_length=9)),
                ('created', models.DateTimeField(default=django.utils.timezone.now, help_text='When was the task created')),
                ('aborted', models.DateTimeField(blank=True, help_text='When was the task aborted', null=True)),
                ('event', models.ForeignKey(blank=True, help_text='Related event', null=True, on_delete=django.db.models.deletion.CASCADE, to='api.Event')),
            ],
        ),
        migrations.CreateModel(
            name='SLOBillingHistory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('billing_time', models.DateTimeField(default=django.utils.timezone.now, help_text='The time the billing was calculated')),
                ('start', models.DateTimeField(help_text='The start time of the billing cycle')),
                ('end', models.DateTimeField(help_text='The end time of the billing cycle')),
                ('value', models.FloatField(default=0, help_text='The SLO value during this cycle')),
                ('status', models.CharField(choices=[('ok', 'OK'), ('broken', 'Broken'), ('completed', 'Completed')], default='ok', help_text='The SLO status during this period', max_length=6)),
                ('slo', models.ForeignKey(help_text='The SLO the the history refers to', on_delete=django.db.models.deletion.CASCADE, related_name='history', to='api.SLO')),
            ],
        ),
        migrations.CreateModel(
            name='Level',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, help_text='The id of the SLO Level', primary_key=True, serialize=False)),
                ('min_value', models.FloatField(default=0, help_text='The minimum value that when reached, the level is activated')),
                ('max_value', models.FloatField(default=0, help_text='The maximum value that when reached, the level is deactivated')),
                ('price_drop_percentage', models.FloatField(default=0, help_text='The price drop percentage')),
                ('status', models.CharField(choices=[('active', 'Active'), ('inactive', 'Inactive')], default='inactive', help_text='The status of the level', max_length=8)),
                ('slo', models.ForeignKey(help_text='The SLO that the level refers to', on_delete=django.db.models.deletion.CASCADE, related_name='levels', to='api.SLO')),
            ],
        ),
        migrations.AddField(
            model_name='event',
            name='slo',
            field=models.ForeignKey(help_text='The SLO that the event refers to', on_delete=django.db.models.deletion.CASCADE, related_name='events', to='api.SLO'),
        ),
        migrations.CreateModel(
            name='ClientToNotify',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('responsible', models.CharField(help_text='Who is the one being notified', max_length=100)),
                ('protocol', models.CharField(choices=[('amqp', 'RabbitMQ'), ('http', 'HTTP'), ('https', 'HTTPS'), ('kafka', 'kafka')], default='http', help_text='The protocol of the notification', max_length=5)),
                ('server', models.CharField(help_text='The server to send the information to', max_length=100)),
                ('port', models.IntegerField(default=443, help_text='The port to connect to')),
                ('service_url', models.CharField(help_text='The rest of the URL to send the information to', max_length=512)),
                ('percentage', models.FloatField(default=80.0, help_text="The percentage of the SLA's SLOs that when reached the notification will be sent")),
                ('last_notified', models.DateTimeField(help_text='When was the last notification sent.')),
                ('sla', models.ForeignKey(blank=True, help_text='The SLA to send notification for', null=True, on_delete=django.db.models.deletion.CASCADE, to='api.SLA')),
            ],
        ),
    ]
